]> git.ipfire.org Git - ipfire-2.x.git/blame_incremental - make.sh
Add dm9601 modules to core12
[ipfire-2.x.git] / make.sh
... / ...
CommitLineData
1#!/bin/bash
2############################################################################
3# #
4# This file is part of the IPFire Firewall. #
5# #
6# IPFire is free software; you can redistribute it and/or modify #
7# it under the terms of the GNU General Public License as published by #
8# the Free Software Foundation; either version 2 of the License, or #
9# (at your option) any later version. #
10# #
11# IPFire is distributed in the hope that it will be useful, #
12# but WITHOUT ANY WARRANTY; without even the implied warranty of #
13# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the #
14# GNU General Public License for more details. #
15# #
16# You should have received a copy of the GNU General Public License #
17# along with IPFire; if not, write to the Free Software #
18# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA #
19# #
20# Copyright (C) 2007 IPFire-Team <info@ipfire.org>. #
21# #
22############################################################################
23#
24
25NAME="IPFire" # Software name
26SNAME="ipfire" # Short name
27VERSION="2.1" # Version number
28SLOGAN="www.ipfire.org" # Software slogan
29CONFIG_ROOT=/var/ipfire # Configuration rootdir
30NICE=10 # Nice level
31MAX_RETRIES=1 # prefetch/check loop
32KVER=`grep --max-count=1 VER lfs/linux | awk '{ print $3 }'`
33MACHINE=`uname -m`
34
35IPFVER="full" # Which versions should be compiled? (full|devel)
36
37# Debian specific settings
38if [ ! -e /etc/debian_version ]; then
39 FULLPATH=`which $0`
40else
41 if [ -x /usr/bin/realpath ]; then
42 FULLPATH=`/usr/bin/realpath $0`
43 else
44 echo "ERROR: Need to do apt-get install realpath"
45 exit 1
46 fi
47fi
48
49PWD=`pwd`
50BASENAME=`basename $0`
51BASEDIR=`echo $FULLPATH | sed "s/\/$BASENAME//g"`
52LOGFILE=$BASEDIR/log/_build.preparation.log
53export BASEDIR LOGFILE
54DIR_CHK=$BASEDIR/cache/check
55mkdir $BASEDIR/log/ 2>/dev/null
56
57# Include funtions
58. tools/make-functions
59
60if [ -f .config ]; then
61 . .config
62else
63 echo -e "${BOLD}No configuration found!${NORMAL}"
64 echo -ne "Do you want to create one (y/N)?"
65 read CREATE_CONFIG
66 echo ""
67 if [ "$CREATE_CONFIG" == "y" ]; then
68 make_config
69 fi
70fi
71
72if [ -z $EDITOR ]; then
73 for i in nano emacs vi; do
74 EDITOR=$(which $i 2>/dev/null)
75 if ! [ -z $EDITOR ]; then
76 export EDITOR=$EDITOR
77 break
78 fi
79 done
80 [ -z $EDITOR ] && exiterror "You should have installed an editor."
81fi
82
83prepareenv() {
84 ############################################################################
85 # #
86 # Are we running the right shell? #
87 # #
88 ############################################################################
89 if [ ! "$BASH" ]; then
90 exiterror "BASH environment variable is not set. You're probably running the wrong shell."
91 fi
92
93 if [ -z "${BASH_VERSION}" ]; then
94 exiterror "Not running BASH shell."
95 fi
96
97
98 ############################################################################
99 # #
100 # Trap on emergency exit #
101 # #
102 ############################################################################
103 trap "exiterror 'Build process interrupted'" SIGINT SIGTERM SIGKILL SIGSTOP SIGQUIT
104
105
106 ############################################################################
107 # #
108 # Resetting our nice level #
109 # #
110 ############################################################################
111 echo -ne "Resetting our nice level to $NICE" | tee -a $LOGFILE
112 renice $NICE $$ > /dev/null
113 if [ `nice` != "$NICE" ]; then
114 beautify message FAIL
115 exiterror "Failed to set correct nice level"
116 else
117 beautify message DONE
118 fi
119
120
121 ############################################################################
122 # #
123 # Checking if running as root user #
124 # #
125 ############################################################################
126 echo -ne "Checking if we're running as root user" | tee -a $LOGFILE
127 if [ `id -u` != 0 ]; then
128 beautify message FAIL
129 exiterror "Not building as root"
130 else
131 beautify message DONE
132 fi
133
134
135 ############################################################################
136 # #
137 # Checking for necessary temporary space #
138 # #
139 ############################################################################
140 echo -ne "Checking for necessary space on disk $BASE_DEV" | tee -a $LOGFILE
141 BASE_DEV=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $1 }'`
142 BASE_ASPACE=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $4 }'`
143 if (( 2048000 > $BASE_ASPACE )); then
144 BASE_USPACE=`du -skx $BASEDIR | awk '{print $1}'`
145 if (( 2048000 - $BASE_USPACE > $BASE_ASPACE )); then
146 beautify message FAIL
147 exiterror "Not enough temporary space available, need at least 2GB on $BASE_DEV"
148 fi
149 else
150 beautify message DONE
151 fi
152
153 ############################################################################
154 # #
155 # Building Linux From Scratch system #
156 # #
157 ############################################################################
158 # Set umask
159 umask 022
160
161 # Set LFS Directory
162 LFS=$BASEDIR/build
163
164 # Check /tools symlink
165 if [ -h /tools ]; then
166 rm -f /tools
167 fi
168 if [ ! -a /tools ]; then
169 ln -s $BASEDIR/build/tools /
170 fi
171 if [ ! -h /tools ]; then
172 exiterror "Could not create /tools symbolic link."
173 fi
174
175 # Setup environment
176 set +h
177 LC_ALL=POSIX
178 MAKETUNING="-j6"
179 export LFS LC_ALL CFLAGS CXXFLAGS MAKETUNING
180 unset CC CXX CPP LD_LIBRARY_PATH LD_PRELOAD
181
182 # Make some extra directories
183 mkdir -p $BASEDIR/build/{tools,etc,usr/src} 2>/dev/null
184 mkdir -p $BASEDIR/build/{dev/{shm,pts},proc,sys}
185 mkdir -p $BASEDIR/{cache,ccache} 2>/dev/null
186 mkdir -p $BASEDIR/build/usr/src/{cache,config,doc,html,langs,lfs,log,src,ccache}
187
188 mknod -m 600 $BASEDIR/build/dev/console c 5 1 2>/dev/null
189 mknod -m 666 $BASEDIR/build/dev/null c 1 3 2>/dev/null
190
191 # Make all sources and proc available under lfs build
192 mount --bind /dev $BASEDIR/build/dev
193 mount --bind /dev/pts $BASEDIR/build/dev/pts
194 mount --bind /dev/shm $BASEDIR/build/dev/shm
195 mount --bind /proc $BASEDIR/build/proc
196 mount --bind /sys $BASEDIR/build/sys
197 mount --bind $BASEDIR/cache $BASEDIR/build/usr/src/cache
198 mount --bind $BASEDIR/ccache $BASEDIR/build/usr/src/ccache
199 mount --bind $BASEDIR/config $BASEDIR/build/usr/src/config
200 mount --bind $BASEDIR/doc $BASEDIR/build/usr/src/doc
201 mount --bind $BASEDIR/html $BASEDIR/build/usr/src/html
202 mount --bind $BASEDIR/langs $BASEDIR/build/usr/src/langs
203 mount --bind $BASEDIR/lfs $BASEDIR/build/usr/src/lfs
204 mount --bind $BASEDIR/log $BASEDIR/build/usr/src/log
205 mount --bind $BASEDIR/src $BASEDIR/build/usr/src/src
206
207 # This is a temporary hack!!!
208 if [ ! -f /tools/bin/hostname ]; then
209 cp -f /bin/hostname /tools/bin/hostname 2>/dev/null
210 fi
211
212 # Run LFS static binary creation scripts one by one
213 export CCACHE_DIR=$BASEDIR/ccache
214 export CCACHE_HASHDIR=1
215
216 # Remove pre-install list of installed files in case user erase some files before rebuild
217 rm -f $BASEDIR/build/usr/src/lsalr 2>/dev/null
218}
219
220buildtoolchain() {
221 LOGFILE="$BASEDIR/log/_build.toolchain.log"
222 export LOGFILE
223 ORG_PATH=$PATH
224 NATIVEGCC=`gcc --version | grep GCC | awk {'print $3'}`
225 export NATIVEGCC GCCmajor=${NATIVEGCC:0:1} GCCminor=${NATIVEGCC:2:1} GCCrelease=${NATIVEGCC:4:1}
226 lfsmake1 ccache
227 lfsmake1 binutils PASS=1
228 lfsmake1 gcc PASS=1
229 export PATH=$BASEDIR/build/usr/local/bin:$BASEDIR/build/tools/bin:$PATH
230 lfsmake1 linux-libc-header
231 lfsmake1 glibc
232 lfsmake1 cleanup-toolchain PASS=1
233 lfsmake1 tcl
234 lfsmake1 expect
235 lfsmake1 dejagnu
236 lfsmake1 gcc PASS=2
237 lfsmake1 binutils PASS=2
238 lfsmake1 ncurses
239 lfsmake1 bash
240 lfsmake1 bzip2
241 lfsmake1 coreutils
242 lfsmake1 diffutils
243 lfsmake1 findutils
244 lfsmake1 gawk
245 lfsmake1 gettext
246 lfsmake1 grep
247 lfsmake1 gzip
248 lfsmake1 m4
249 lfsmake1 make
250 lfsmake1 patch
251 lfsmake1 perl
252 lfsmake1 sed
253 lfsmake1 tar
254 lfsmake1 texinfo
255 lfsmake1 util-linux
256 lfsmake1 cleanup-toolchain PASS=2
257 export PATH=$ORG_PATH
258}
259
260buildbase() {
261 LOGFILE="$BASEDIR/log/_build.base.log"
262 export LOGFILE
263 lfsmake2 stage2
264 lfsmake2 linux-libc-header
265 lfsmake2 man-pages
266 lfsmake2 glibc
267 lfsmake2 cleanup-toolchain PASS=3
268 lfsmake2 binutils
269 lfsmake2 gcc
270 lfsmake2 berkeley
271 lfsmake2 coreutils
272 lfsmake2 iana-etc
273 lfsmake2 m4
274 lfsmake2 bison
275 lfsmake2 ncurses
276 lfsmake2 procps
277 lfsmake2 sed
278 lfsmake2 libtool
279 lfsmake2 perl
280 lfsmake2 readline
281 lfsmake2 zlib
282 lfsmake2 autoconf
283 lfsmake2 automake
284 lfsmake2 bash
285 lfsmake2 bzip2
286 lfsmake2 diffutils
287 lfsmake2 e2fsprogs
288 lfsmake2 ed
289 lfsmake2 file
290 lfsmake2 findutils
291 lfsmake2 flex
292 lfsmake2 gawk
293 lfsmake2 gettext
294 lfsmake2 grep
295 lfsmake2 groff
296 lfsmake2 gzip
297 lfsmake2 inetutils
298 lfsmake2 iproute2
299 lfsmake2 kbd
300 lfsmake2 less
301 lfsmake2 libaal
302 lfsmake2 make
303 lfsmake2 man
304 lfsmake2 mktemp
305 lfsmake2 modutils
306 lfsmake2 mtd
307 lfsmake2 net-tools
308 lfsmake2 patch
309 lfsmake2 psmisc
310 lfsmake2 reiser4progs
311 lfsmake2 shadow
312 lfsmake2 sysklogd
313 lfsmake2 sysvinit
314 lfsmake2 tar
315 lfsmake2 texinfo
316 lfsmake2 udev
317 lfsmake2 util-linux
318 lfsmake2 vim
319 lfsmake2 grub
320}
321
322buildipfire() {
323 LOGFILE="$BASEDIR/log/_build.ipfire.log"
324 export LOGFILE
325 ipfiremake configroot
326 ipfiremake backup
327 ipfiremake dhcp
328 ipfiremake dhcpcd
329 ipfiremake libusb
330 ipfiremake libpcap
331 ipfiremake ppp
332 ipfiremake rp-pppoe
333 ipfiremake unzip
334 ipfiremake linux SMP=1
335 ipfiremake ipp2p SMP=1
336 ipfiremake zaptel SMP=1
337 ipfiremake r8169 SMP=1
338 ipfiremake r8168 SMP=1
339 ipfiremake mcs7830 SMP=1
340 ipfiremake atl1 SMP=1
341 ipfiremake dm9601 SMP=1
342 ipfiremake kqemu SMP=1
343 ipfiremake sane KMOD=1 SMP=1
344 ipfiremake linux
345 ipfiremake ipp2p
346 ipfiremake zaptel
347 ipfiremake r8169
348 ipfiremake r8168
349 ipfiremake mcs7830
350 ipfiremake atl1
351 ipfiremake dm9601
352 ipfiremake kqemu
353 ipfiremake sane KMOD=1
354 ipfiremake pkg-config
355 ipfiremake linux-atm
356 ipfiremake cpio
357 ipfiremake klibc
358 ipfiremake mkinitcpio
359 ipfiremake udev KLIBC=1
360 ipfiremake expat
361 ipfiremake gdbm
362 ipfiremake gmp
363 ipfiremake pam
364 ipfiremake openssl
365 ipfiremake curl
366 ipfiremake python
367 ipfiremake libnet
368 ipfiremake libidn
369 ipfiremake libjpeg
370 ipfiremake libpng
371 ipfiremake libtiff
372 ipfiremake libart
373 ipfiremake freetype
374 ipfiremake gd
375 ipfiremake popt
376 ipfiremake pcre
377 ipfiremake slang
378 ipfiremake newt
379 ipfiremake libcap
380 ipfiremake pciutils
381 ipfiremake usbutils
382 ipfiremake libxml2
383 ipfiremake libxslt
384 ipfiremake BerkeleyDB
385 ipfiremake mysql
386 ipfiremake cyrus-sasl
387 ipfiremake openldap
388 ipfiremake apache2
389 ipfiremake php
390 ipfiremake apache2 PASS=C
391 ipfiremake arping
392 ipfiremake beep
393 ipfiremake bind
394 ipfiremake cdrtools
395 ipfiremake dnsmasq
396 ipfiremake dosfstools
397 ipfiremake squashfstools
398 ipfiremake reiserfsprogs
399 ipfiremake xfsprogs
400 ipfiremake sysfsutils
401 ipfiremake fuse
402 ipfiremake ntfs-3g
403 ipfiremake ethtool
404 ipfiremake ez-ipupdate
405 ipfiremake fcron
406 ipfiremake perl-GD
407 ipfiremake GD-Graph
408 ipfiremake GD-TextUtil
409 ipfiremake gnupg
410 ipfiremake hdparm
411 ipfiremake sdparm
412 ipfiremake mtools
413 ipfiremake initscripts
414 ipfiremake whatmask
415 ipfiremake iptables
416 ipfiremake libupnp
417 ipfiremake ipp2p IPT=1
418 ipfiremake linux-igd
419 ipfiremake ipac-ng
420 ipfiremake ipaddr
421 ipfiremake iptstate
422 ipfiremake iputils
423 ipfiremake l7-protocols
424 ipfiremake mISDN
425 ipfiremake capi4k-utils
426 ipfiremake hwdata
427 ipfiremake kudzu
428 ipfiremake logrotate
429 ipfiremake logwatch
430 ipfiremake misc-progs
431 ipfiremake nano
432 ipfiremake nasm
433 ipfiremake URI
434 ipfiremake HTML-Tagset
435 ipfiremake HTML-Parser
436 ipfiremake Compress-Zlib
437 ipfiremake Digest
438 ipfiremake Digest-SHA1
439 ipfiremake Digest-HMAC
440 ipfiremake libwww-perl
441 ipfiremake Net-DNS
442 ipfiremake Net-IPv4Addr
443 ipfiremake Net_SSLeay
444 ipfiremake IO-Stringy
445 ipfiremake Unix-Syslog
446 ipfiremake Mail-Tools
447 ipfiremake MIME-Tools
448 ipfiremake Net-Server
449 ipfiremake Convert-TNEF
450 ipfiremake Convert-UUlib
451 ipfiremake Archive-Tar
452 ipfiremake Archive-Zip
453 ipfiremake Text-Tabs+Wrap
454 ipfiremake Locale-Country
455 ipfiremake XML-Parser
456 ipfiremake glib
457 ipfiremake GeoIP
458 ipfiremake fwhits
459 ipfiremake noip_updater
460 ipfiremake ntp
461 ipfiremake openssh
462 ipfiremake openswan
463 ipfiremake rrdtool
464 ipfiremake setserial
465 ipfiremake setup
466 ipfiremake snort
467 ipfiremake oinkmaster
468 ipfiremake squid
469 ipfiremake squid-graph
470 ipfiremake squidguard
471 ipfiremake calamaris
472 ipfiremake tcpdump
473 ipfiremake traceroute
474 ipfiremake vlan
475 ipfiremake wireless
476 ipfiremake libsafe
477 ipfiremake pakfire
478 ipfiremake java
479 ipfiremake spandsp
480 ipfiremake lzo
481 ipfiremake openvpn
482 ipfiremake pammysql
483 ipfiremake cups
484 ipfiremake ghostscript
485 ipfiremake foomatic
486 ipfiremake hplip
487 ipfiremake samba
488 ipfiremake sudo
489 ipfiremake mc
490 ipfiremake wget
491 ipfiremake bridge-utils
492 ipfiremake screen
493 ipfiremake hddtemp
494 ipfiremake smartmontools
495 ipfiremake htop
496 ipfiremake postfix
497 ipfiremake fetchmail
498 ipfiremake cyrus-imapd
499 ipfiremake openmailadmin
500 ipfiremake clamav
501 ipfiremake spamassassin
502 ipfiremake amavisd
503 ipfiremake alsa
504 ipfiremake mpg123
505 ipfiremake mpfire
506 ipfiremake guardian
507 ipfiremake libid3tag
508 ipfiremake libmad
509 ipfiremake libogg
510 ipfiremake libvorbis
511 ipfiremake lame
512 ipfiremake sox
513 ipfiremake libshout
514 ipfiremake icecast
515 ipfiremake icegenerator
516 ipfiremake mpd
517 ipfiremake mpc
518 ipfiremake xvid
519 ipfiremake libmpeg2
520 ipfiremake videolan
521 ipfiremake cmake
522 ipfiremake libpri
523 ipfiremake asterisk
524 ipfiremake gnump3d
525 ipfiremake libsigc++
526 ipfiremake applejuice
527 ipfiremake ocaml
528 ipfiremake mldonkey
529 ipfiremake libtorrent
530 ipfiremake rtorrent
531 ipfiremake ipfireseeder
532 ipfiremake rsync
533 ipfiremake tcpwrapper
534 ipfiremake portmap
535 ipfiremake nfs
536 ipfiremake nmap
537 ipfiremake mbmon
538 ipfiremake ncftp
539 ipfiremake etherwake
540 ipfiremake bwm-ng
541 ipfiremake tripwire
542 ipfiremake sysstat
543 ipfiremake vsftpd
544 ipfiremake which
545 ipfiremake lsof
546 ipfiremake centerim
547 ipfiremake br2684ctl
548 ipfiremake pcmciautils
549 ipfiremake collectd
550 ipfiremake lcd4linux
551 ipfiremake neon
552 ipfiremake subversion
553 ipfiremake tcptrack
554 ipfiremake teamspeak
555 ipfiremake elinks
556 ipfiremake igmpproxy
557 ipfiremake sdl
558 ipfiremake qemu
559 ipfiremake sane
560 ipfiremake netpbm
561 ipfiremake phpSANE
562 ipfiremake tunctl
563 ipfiremake nagios
564 ipfiremake ebtables
565 ipfiremake arptables
566 ipfiremake fontconfig
567 ipfiremake freefont
568 ipfiremake vdr
569 ipfiremake w_scan
570 ipfiremake git
571 ipfiremake squidclamav
572 ipfiremake bc
573}
574
575buildinstaller() {
576 # Run installer scripts one by one
577 LOGFILE="$BASEDIR/log/_build.installer.log"
578 export LOGFILE
579 ipfiremake syslinux
580 ipfiremake as86
581 ipfiremake mbr
582 ipfiremake memtest
583 installmake linux-libc-header
584 installmake binutils
585 ipfiremake uClibc PASS=1
586 ipfiremake gcc INST=1
587 installmake uClibc PASS=2
588 installmake gcc INST=2
589 installmake uClibc PASS=3
590 installmake busybox
591 installmake udev
592 installmake slang
593 installmake newt
594 installmake gettext
595 installmake kbd
596 installmake popt
597 installmake sysvinit
598 installmake misc-progs
599 installmake libaal
600 installmake reiser4progs
601 installmake reiserfsprogs
602 installmake sysfsutils
603 installmake util-linux
604 installmake pciutils
605 installmake zlib
606 installmake mtd
607 installmake wget
608 installmake hwdata
609 installmake kudzu
610 installmake pcmciautils
611 installmake installer
612 installmake initrd
613}
614
615buildpackages() {
616 LOGFILE="$BASEDIR/log/_build.packages.log"
617 export LOGFILE
618 echo "... see detailed log in _build.*.log files" >> $LOGFILE
619
620 installmake strip
621
622 # Generating list of packages used
623 echo -n "Generating packages list from logs" | tee -a $LOGFILE
624 rm -f $BASEDIR/doc/packages-list
625 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
626 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
627 echo "* `basename $i`" >>$BASEDIR/doc/packages-list
628 fi
629 done
630 echo "== List of softwares used to build $NAME Version: $VERSION ==" > $BASEDIR/doc/packages-list.txt
631 grep -v 'configroot$\|img$\|initrd$\|initscripts$\|installer$\|install$\|setup$\|pakfire$\|stage2$\|smp$\|tools$\|tools1$\|tools2$\|.tgz$\|-config$\|_missing_rootfile$\|install1$\|install2$\|pass1$\|pass2$\|pass3$' \
632 $BASEDIR/doc/packages-list | sort >> $BASEDIR/doc/packages-list.txt
633 rm -f $BASEDIR/doc/packages-list
634 # packages-list.txt is ready to be displayed for wiki page
635 beautify message DONE
636
637 # Create images for install
638 ipfiremake cdrom ED=full
639
640 # Check if there is a loop device for building in virtual environments
641 if [ -e /dev/loop/0 ] || [ -e /dev/loop0 ]; then
642 ipfiremake usb-stick
643 fi
644 mv $LFS/install/images/{*.iso,*.tgz,*.img.gz} $BASEDIR >> $LOGFILE 2>&1
645
646 ipfirepackages
647
648 # Cleanup
649 stdumount
650 rm -rf $BASEDIR/build/tmp/*
651
652 # Generating total list of files
653 echo -n "Generating files list from logs" | tee -a $LOGFILE
654 rm -f $BASEDIR/log/FILES
655 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
656 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
657 echo "##" >>$BASEDIR/log/FILES
658 echo "## `basename $i`" >>$BASEDIR/log/FILES
659 echo "##" >>$BASEDIR/log/FILES
660 cat $i | sed "s%^\./%#%" | sort >> $BASEDIR/log/FILES
661 fi
662 done
663 beautify message DONE
664
665 cd $PWD
666}
667
668ipfirepackages() {
669 ipfiremake core-updates
670 for i in $(ls -1 $BASEDIR/config/rootfiles/packages); do
671 if [ -e $BASEDIR/lfs/$i ]; then
672 ipfiredist $i
673 else
674 echo -n $i
675 beautify message SKIP
676 fi
677 done
678 test -d $BASEDIR/packages || mkdir $BASEDIR/packages
679 mv -f $LFS/install/packages/* $BASEDIR/packages >> $LOGFILE 2>&1
680 rm -rf $BASEDIR/build/install/packages/*
681}
682
683# See what we're supposed to do
684case "$1" in
685build)
686 clear
687 BUILDMACHINE=`uname -m`
688 PACKAGE=`ls -v -r $BASEDIR/cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz 2> /dev/null | head -n 1`
689 #only restore on a clean disk
690 if [ ! -f log/cleanup-toolchain-2-tools ]; then
691 if [ ! -n "$PACKAGE" ]; then
692 beautify build_stage "Full toolchain compilation - Native GCC: `gcc --version | grep GCC | awk {'print $3'}`"
693 prepareenv
694 buildtoolchain
695 else
696 PACKAGENAME=${PACKAGE%.tar.gz}
697 beautify build_stage "Packaged toolchain compilation"
698 if [ `md5sum $PACKAGE | awk '{print $1}'` == `cat $PACKAGENAME.md5 | awk '{print $1}'` ]; then
699 tar zxf $PACKAGE
700 prepareenv
701 else
702 exiterror "$PACKAGENAME md5 did not match, check downloaded package"
703 fi
704 fi
705 else
706 echo -n "Using installed toolchain" | tee -a $LOGFILE
707 beautify message SKIP
708 prepareenv
709 fi
710
711 beautify build_start
712 beautify build_stage "Building LFS"
713 buildbase
714
715 beautify build_stage "Building IPFire"
716 buildipfire
717
718 beautify build_stage "Building installer"
719 buildinstaller
720
721 beautify build_stage "Building packages"
722 buildpackages
723 beautify build_end
724 ;;
725shell)
726 # enter a shell inside LFS chroot
727 # may be used to changed kernel settings
728 prepareenv
729 entershell
730 ;;
731clean)
732 echo -en "${BOLD}Cleaning build directory...${NORMAL}"
733 for i in `mount | grep $BASEDIR | sed 's/^.*loop=\(.*\))/\1/'`; do
734 $LOSETUP -d $i 2>/dev/null
735 done
736 for i in `mount | grep $BASEDIR | cut -d " " -f 1`; do
737 umount $i
738 done
739 stdumount
740 for i in `seq 0 7`; do
741 if ( losetup /dev/loop${i} 2>/dev/null | grep -q "/install/images" ); then
742 umount /dev/loop${i} 2>/dev/null;
743 losetup -d /dev/loop${i} 2>/dev/null;
744 fi;
745 done
746 rm -rf $BASEDIR/build
747 rm -rf $BASEDIR/cdrom
748 rm -rf $BASEDIR/packages
749 rm -rf $BASEDIR/log
750 if [ -h /tools ]; then
751 rm -f /tools
752 fi
753 beautify message DONE
754 ;;
755downloadsrc)
756 if [ ! -d $BASEDIR/cache ]; then
757 mkdir $BASEDIR/cache
758 fi
759 mkdir -p $BASEDIR/log
760 echo -e "${BOLD}Preload all source files${NORMAL}" | tee -a $LOGFILE
761 FINISHED=0
762 cd $BASEDIR/lfs
763 for c in `seq $MAX_RETRIES`; do
764 if (( FINISHED==1 )); then
765 break
766 fi
767 FINISHED=1
768 cd $BASEDIR/lfs
769 for i in *; do
770 if [ -f "$i" -a "$i" != "Config" ]; then
771 echo -ne "Loading $i"
772 make -s -f $i LFS_BASEDIR=$BASEDIR MESSAGE="$i\t ($c/$MAX_RETRIES)" download >> $LOGFILE 2>&1
773 if [ $? -ne 0 ]; then
774 beautify message FAIL
775 FINISHED=0
776 else
777 if [ $c -eq 1 ]; then
778 beautify message DONE
779 fi
780 fi
781 fi
782 done
783 done
784 echo -e "${BOLD}***Verifying md5sums${NORMAL}"
785 ERROR=0
786 for i in *; do
787 if [ -f "$i" -a "$i" != "Config" ]; then
788 make -s -f $i LFS_BASEDIR=$BASEDIR MESSAGE="$i\t " md5 >> $LOGFILE 2>&1
789 if [ $? -ne 0 ]; then
790 echo -ne "MD5 difference in lfs/$i"
791 beautify message FAIL
792 ERROR=1
793 fi
794 fi
795 done
796 if [ $ERROR -eq 0 ]; then
797 echo -ne "${BOLD}all files md5sum match${NORMAL}"
798 beautify message DONE
799 else
800 echo -ne "${BOLD}not all files were correctly download${NORMAL}"
801 beautify message FAIL
802 fi
803 cd - >/dev/null 2>&1
804 ;;
805toolchain)
806 clear
807 prepareenv
808 beautify build_stage "Toolchain compilation - Native GCC: `gcc --version | grep GCC | awk {'print $3'}`"
809 buildtoolchain
810 BUILDMACHINE=`uname -m`
811 echo "`date -u '+%b %e %T'`: Create toolchain tar.gz for $BUILDMACHINE" | tee -a $LOGFILE
812 test -d $BASEDIR/cache/toolchains || mkdir $BASEDIR/cache/toolchains
813 cd $BASEDIR && tar -zc --exclude='log/_build.*.log' -f cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz \
814 build/{bin,etc,usr/bin,usr/local} \
815 build/tools/{bin,etc,*-linux-gnu,include,lib,libexec,sbin,share,var} \
816 log >> $LOGFILE
817 md5sum cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz \
818 > cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.md5
819 stdumount
820 ;;
821gettoolchain)
822 BUILDMACHINE=`uname -m`
823 # arbitrary name to be updated in case of new toolchain package upload
824 PACKAGE=$SNAME-$VERSION-toolchain-$BUILDMACHINE
825 if [ ! -f $BASEDIR/cache/toolchains/$PACKAGE.tar.gz ]; then
826 URL_TOOLCHAIN=`grep URL_TOOLCHAIN lfs/Config | awk '{ print $3 }'`
827 test -d $BASEDIR/cache/toolchains || mkdir $BASEDIR/cache/toolchains
828 echo "`date -u '+%b %e %T'`: Load toolchain tar.gz for $BUILDMACHINE" | tee -a $LOGFILE
829 cd $BASEDIR/cache/toolchains
830 wget $URL_TOOLCHAIN/$PACKAGE.tar.gz $URL_TOOLCHAIN/$PACKAGE.md5 >& /dev/null
831 if [ $? -ne 0 ]; then
832 echo "`date -u '+%b %e %T'`: error downloading toolchain for $BUILDMACHINE machine" | tee -a $LOGFILE
833 else
834 if [ "`md5sum $PACKAGE.tar.gz | awk '{print $1}'`" = "`cat $PACKAGE.md5 | awk '{print $1}'`" ]; then
835 echo "`date -u '+%b %e %T'`: toolchain md5 ok" | tee -a $LOGFILE
836 else
837 exiterror "$PACKAGE.md5 did not match, check downloaded package"
838 fi
839 fi
840 else
841 echo "Toolchain is already downloaded. Exiting..."
842 fi
843 ;;
844othersrc)
845 prepareenv
846 echo -ne "`date -u '+%b %e %T'`: Build sources iso for $MACHINE" | tee -a $LOGFILE
847 chroot $LFS /tools/bin/env -i HOME=/root \
848 TERM=$TERM PS1='\u:\w\$ ' \
849 PATH=/usr/local/bin:/bin:/usr/bin:/sbin:/usr/sbin \
850 VERSION=$VERSION NAME="$NAME" SNAME="$SNAME" MACHINE=$MACHINE \
851 /bin/bash -x -c "cd /usr/src/lfs && make -f sources-iso LFS_BASEDIR=/usr/src install" >>$LOGFILE 2>&1
852 mv $LFS/install/images/ipfire-* $BASEDIR >> $LOGFILE 2>&1
853 if [ $? -eq "0" ]; then
854 beautify message DONE
855 else
856 beautify message FAIL
857 fi
858 stdumount
859 ;;
860git)
861 case "$2" in
862 update|up)
863 git pull
864 ;;
865 commit|ci)
866 shift 2
867 git commit $*
868
869 [ "$?" -eq "0" ] || exiterror "git commit $* failed."
870
871 echo -e "${BOLD}Do you want to push, too? [y/N]${NORMAL}"
872 read
873 [ -z $REPLY ] && exit 0
874 for i in y Y j J; do
875 if [ "$i" == "$REPLY" ]; then
876 $0 git push
877 exit $?
878 fi
879 done
880 exiterror "\"$REPLY\" is not a valid answer."
881 ;;
882 dist)
883 git archive HEAD | gzip -9 > ${SNAME}-${VERSION}.tar.gz
884 ;;
885 diff|di)
886 echo -ne "Make a local diff to last revision"
887 git diff HEAD > ipfire-diff-$(date +'%Y-%m-%d-%H:%M').diff
888 evaluate 1
889 echo "Diff was successfully saved to ipfire-diff-$(date +'%Y-%m-%d-%H:%M').diff"
890 git diff --stat
891 ;;
892 push)
893 [ -z $GIT_USER ] && exiterror "You have to setup GIT_USER first."
894 GIT_URL="ssh://${GIT_USER}@git.ipfire.org/pub/git/ipfire-2.x"
895
896 git push ${GIT_URL} master
897 ;;
898 esac
899 ;;
900uploadsrc)
901 PWD=`pwd`
902 cd $BASEDIR/cache/
903 echo -e "Uploading cache to ftp server:"
904 ncftpls -u $FTP_CACHE_USER -p $FTP_CACHE_PASS ftp://$FTP_CACHE_URL/$FTP_CACHE_PATH/ > /tmp/ftplist
905 for i in *; do
906 if [ "$(basename $i)" == "toolchains" ]; then continue; fi
907 grep -q $(basename $i) /tmp/ftplist
908 if [ "$?" -ne "0" ]; then
909 echo -ne "$(basename $i)"
910 ncftpput -u $FTP_CACHE_USER -p $FTP_CACHE_PASS $FTP_CACHE_URL $FTP_CACHE_PATH/ $(basename $i)
911 if [ "$?" -ne "0" ]; then
912 beautify message FAIL
913 fi
914 fi
915 done
916 rm -f /tmp/ftplist
917 cd $PWD
918 exit 0
919 ;;
920upload)
921 FTP_ISO_PORT=`echo "$FTP_ISO_URL" | awk -F: '{ print $2 }'`
922 FTP_ISO_URL=`echo "$FTP_ISO_URL" | awk -F: '{ print $1 }'`
923 if [ -z $FTP_ISO_PORT ]; then
924 FTP_ISO_PORT=21
925 fi
926 cat <<EOF > .ftp-commands
927mkdir -p $FTP_ISO_PATH$SVN_REVISION
928mkdir -p $FTP_ISO_PATH$SVN_REVISION/paks
929quit
930EOF
931 ncftp -u $FTP_ISO_USER -p $FTP_ISO_PASS -P $FTP_ISO_PORT $FTP_ISO_URL < .ftp-commands
932 rm -f .ftp-commands
933
934 case "$2" in
935 iso)
936 echo -e "Uploading the iso to $FTP_ISO_PATH/$SVN_REVISION."
937
938 md5sum ipfire-$VERSION.$MACHINE-full.iso > ipfire-$VERSION.$MACHINE-full.iso.md5
939 for i in svn_status ipfire-source-r$SVN_REVISION.tar.gz ipfire-$VERSION.$MACHINE-full.iso ipfire-$VERSION.$MACHINE-full.iso.md5 ipfire-$VERSION.$MACHINE-devel.iso ipfire-$VERSION.$MACHINE-devel.iso.md5; do
940 if [ -e "$i" ]; then
941 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS -P $FTP_ISO_PORT $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/ $i
942 if [ "$?" -eq "0" ]; then
943 echo "The file with name $i was successfully uploaded to $FTP_ISO_URL$FTP_ISO_PATH$SVN_REVISION/."
944 else
945 echo "There was an error while uploading the file $i to the ftp server."
946 exit 1
947 fi
948 fi
949 done
950 rm -f ipfire-$VERSION.$MACHINE-full.iso.md5
951 if [ "$3" = "--with-sources-cd" ]; then
952 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS -P $FTP_ISO_PORT $FTP_ISO_URL $FTP_ISO_PATH/$SVN_REVISION/ ipfire-sources-cd-$VERSION.$MACHINE.iso
953 fi
954 ;;
955 paks)
956 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS -P $FTP_ISO_PORT $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/paks packages/*
957 if [ "$?" -eq "0" ]; then
958 echo -e "The packages were successfully uploaded to $FTP_ISO_URL$FTP_ISO_PATH$SVN_REVISION/."
959 else
960 echo -e "There was an error while uploading the packages to the ftp server."
961 exit 1
962 fi
963 ;;
964 esac
965 ;;
966batch)
967 if [ "$2" = "--background" ]; then
968 batch_script
969 exit $?
970 fi
971 if [ `screen -ls | grep -q ipfire` ]; then
972 echo "Build is already running, sorry!"
973 exit 1
974 else
975 if [ "$2" = "--rebuild" ]; then
976 export IPFIRE_REBUILD=1
977 echo "REBUILD!"
978 else
979 export IPFIRE_REBUILD=0
980 fi
981 echo -en "${BOLD}***IPFire-Batch-Build is starting...${NORMAL}"
982 screen -dmS ipfire $0 batch --background
983 evaluate 1
984 exit 0
985 fi
986 ;;
987watch)
988 watch_screen
989 ;;
990pxe)
991 case "$2" in
992 start)
993 start_tftpd
994 ;;
995 stop)
996 stop_tftpd
997 ;;
998 reload|restart)
999 reload_tftpd
1000 ;;
1001 esac
1002 exit 0
1003 ;;
1004lang)
1005 update_langs
1006 ;;
1007"")
1008 clear
1009 select name in "Exit" "IPFIRE: Downloadsrc" "IPFIRE: Build (silent)" "IPFIRE: Watch Build" "IPFIRE: Batch" "IPFIRE: Clean" "LOG: Tail" "Help"
1010 do
1011 case $name in
1012 "IPFIRE: Downloadsrc")
1013 $0 downloadsrc
1014 ;;
1015 "IPFIRE: Build (silent)")
1016 $0 build-silent
1017 ;;
1018 "IPFIRE: Watch Build")
1019 $0 watch
1020 ;;
1021 "IPFIRE: Batch")
1022 $0 batch
1023 ;;
1024 "IPFIRE: Clean")
1025 $0 clean
1026 ;;
1027 "Help")
1028 echo "Usage: $0 {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain}"
1029 cat doc/make.sh-usage
1030 ;;
1031 "LOG: Tail")
1032 tail -f log/_*
1033 ;;
1034 "Exit")
1035 break
1036 ;;
1037 esac
1038 done
1039 ;;
1040config)
1041 make_config
1042 ;;
1043*)
1044 echo "Usage: $0 {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain}"
1045 cat doc/make.sh-usage
1046 ;;
1047esac